"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

JavaByteCodeProcessorAdapter subclass:#C1BasicBlockAnalyzerJava
	instanceVariableNames:'blocks entry current'
	classVariableNames:''
	poolDictionaries:''
	category:'DragonFly-C1-Java'
!

!C1BasicBlockAnalyzerJava class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1BasicBlockAnalyzerJava class methodsFor:'processing'!

process: aJavaMethod
    ^ self new process: aJavaMethod

    "Created: / 14-08-2016 / 16:06:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1BasicBlockAnalyzerJava methodsFor:'instructions'!

areturn
    current endPC: pc - 1.
    current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 15-08-2016 / 11:18:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

dreturn
    current endPC: pc - 1.
    current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 15-08-2016 / 11:18:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

goto
     self goto: self fetchBytes2.
     current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 14-08-2016 / 15:59:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

goto: delta
    | sourcePC targetPC |

    sourcePC := pc - 3.
    targetPC := sourcePC + delta.
    current endPC: sourcePC.
    delta > 0 ifTrue:[
        "/ Forward jump - just creare a new basic block for future use.
        "/ See #switch:
        self blockAtPC: targetPC successorOfCurrent: true.
    ] ifFalse:[ 
        "/ Backward jump, we need to find a block that contains
        "/ the PC and split it in two.
        current withAllPrecedessorsDo:[ :block |
            (targetPC between: block startPC and: block endPC) ifTrue:[ 
                | splitted |
                splitted := block splitAtPC: targetPC.
                blocks at: targetPC put: splitted.
                block == current ifTrue:[ 
                    current := splitted.
                ].
                current addSuccessor: splitted.
            ].
        ]
    ].

    "Created: / 15-08-2016 / 09:12:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-08-2016 / 17:09:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifeq
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:00:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:50:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifge
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:02:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:50:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifgt
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:02:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:50:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmpeq
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:50:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmpge
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmpgt
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmple
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmplt
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ificmpne
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:03:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifle
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:02:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

iflt
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:02:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifne
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:01:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ifnonnull
    self goto: self fetchBytes2.
    current := self blockAtPC:pc successorOfCurrent:true.

    "Created: / 14-08-2016 / 16:02:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:51:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ireturn
    current endPC: pc - 1.
    current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 15-08-2016 / 11:18:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lreturn
    current endPC: pc - 1.
    current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 15-08-2016 / 11:18:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

return
    current endPC: pc - 1.
    current := self blockAtPC:pc successorOfCurrent:false.

    "Created: / 15-08-2016 / 11:19:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1BasicBlockAnalyzerJava methodsFor:'private'!

blockAtPC:anInteger successorOfCurrent:aBoolean 
    | block |

    block := blocks at: anInteger ifAbsentPut:[ C1BasicBlock new startPC:anInteger ].
    aBoolean ifTrue:[
        current endPC isNil ifTrue:[
            current endPC:anInteger - 1.
        ].
        current addSuccessor:block.
    ].
    ^ block.

    "Created: / 15-08-2016 / 10:49:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-08-2016 / 14:55:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1BasicBlockAnalyzerJava methodsFor:'processing loop'!

process:aMethod
    blocks := Dictionary new.
    current := C1BasicBlock new.
    current startPC: 1.
    blocks at: 1 put: current.       
    super process: aMethod.
    ^ blocks at: 1.

    "Created: / 14-08-2016 / 16:06:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 22:11:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

switch: opcode
    | block |

    block := blocks at: pc - 1 ifAbsent:[ nil ].
    (block notNil and:[current startPC ~~ (pc - 1) ]) ifTrue:[ 
        current endPC isNil ifTrue:[ 
            current endPC:  pc - 2.
            current addSuccessor: block.
        ].
        current := block.
    ].
    super switch: opcode

    "Created: / 15-08-2016 / 09:33:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-08-2016 / 10:38:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

