"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

C1Value subclass:#C1NumericValue
	instanceVariableNames:'numValue'
	classVariableNames:''
	poolDictionaries:''
	category:'DragonFly-C1'
!

C1NumericValue class instanceVariableNames:'numType'

"
 No other class instance variables are inherited by this class.
"
!

!C1NumericValue class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1NumericValue class methodsFor:'testing'!

isAbstract
    ^ self == DragonFly::C1NumericValue
! !

!C1NumericValue methodsFor:'accessing'!

numType
    ^ self subclassResponsibility

    "Created: / 06-08-2016 / 07:33:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValue
    numValue isNil ifTrue:[ 
        numValue := self numValueFromObjValue: self objValue.
    ].
    ^ numValue

    "Modified: / 06-08-2016 / 09:22:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValue:anLLVMTypeOrNumber
    anLLVMTypeOrNumber isNumber ifTrue:[ 
        numValue := self numValueFromConstant:anLLVMTypeOrNumber
    ] ifFalse:[ 
        self assert: anLLVMTypeOrNumber isLLVMValue.
        self assert: anLLVMTypeOrNumber type = self numType.
        numValue := anLLVMTypeOrNumber.
    ].

    "Modified: / 06-08-2016 / 08:58:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1NumericValue methodsFor:'private'!

numValueFromConstant:aNumber 
    self subclassResponsibility.

    "Created: / 06-08-2016 / 08:59:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValueFromObjValue: objVal
    ^ backend valInteger32: objVal.

    "Created: / 06-08-2016 / 09:24:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-08-2016 / 23:37:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

objValueFromNumValue: numVal
    self subclassResponsibility.

    "Created: / 06-08-2016 / 09:24:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1NumericValue class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

