"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1/tests' }"

"{ NameSpace: DragonFly }"

TestCase subclass:#C1CompilerJavaTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DragonFly-C1-Tests'
!

!C1CompilerJavaTests class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1CompilerJavaTests methodsFor:'tests'!

test_m01a
    | cls |

    cls := JAVA jv dragonfly c1 tests C1CompilerJavaTests.

    self compile: #'m01a()I' in: cls.
    self assert: cls new m01a == 15.

    "Created: / 09-08-2016 / 08:32:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_m02a
    | cls |

    cls := JAVA jv dragonfly c1 tests C1CompilerJavaTests.

    self compile: #'m02a(I)I' in: cls.
    self assert: (cls new m02a:15) == 15.

    "Created: / 09-08-2016 / 09:41:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_m03a
    | cls |

    cls := JAVA jv dragonfly c1 tests C1CompilerJavaTests.

    self compile: #'m03a(II)I' in: cls.
    self assert: (cls new m03a:1 _:2) == 3.

    "Created: / 09-08-2016 / 23:49:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_m04a
    | cls |

    cls := JAVA jv dragonfly c1 tests C1CompilerJavaTests.

    self compile: #'m04a(I)I' in: cls.
    "
    (cls >> #'m04a(I)I') code
    " 
    self assert: (cls new m04a:1 ) == 1.

    "Created: / 14-08-2016 / 16:08:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 24-09-2016 / 22:59:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_m04b
    | cls |

    cls := JAVA jv dragonfly c1 tests C1CompilerJavaTests.

    self compile: #'m04b(I)I' in: cls.
    "
    (cls >> #'m04b(I)I') address
    "
    self assert: (cls new m04b:5 ) == 5 factorial.

    "Created: / 16-08-2016 / 17:11:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 17-08-2016 / 22:47:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 24-08-2016 / 22:29:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1CompilerJavaTests methodsFor:'utilities'!

compile: selector in: class
    | method |

    method := class >> selector.
    method code: nil.
    C1CompilerJava compile: method.
    self assert: method code isExternalAddress.
    Stdout nextPutLine: 'Code is at: 0x', (method code address printStringRadix:16).

    "Created: / 30-07-2016 / 00:12:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 24-09-2016 / 23:02:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1CompilerJavaTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

